/* globals Services, sendAsyncMessage, addMessageListener, removeMessageListener */

(function() {
	"use strict";

	var
		app_name = "Viewhance".toLowerCase(),
		app_baseURI = "chrome://" + app_name + "/content/includes/",
		listeners = {},
		listener_ON = function(id, fn) {
			listener_OFF(id);
			listeners[id] = function(msg) {
				fn(msg.data);
			};
			addMessageListener(id, listeners[id]);
		},
		listener_OFF = function(id) {
			if (listeners[id]) {
				removeMessageListener(id, listeners[id]);
			}

			listeners[id] = null;
		};

	var DOM_observer = {
		observe: function(win) {
			if (!content) {
				Services.obs.removeObserver(DOM_observer, "content-document-global-created");
				DOM_observer = null;
				return;
			}
			else if (win.document !== content.document
				|| !(win.document instanceof win.ImageDocument
					|| win.document instanceof win.HTMLDocument
						&& (/^(https?|f(tp|ile)):$/.test(win.location.protocol)))) {
				return;
			}

			win = Components.utils.Sandbox([win], {
				sandboxPrototype: win,
				wantComponents: false,
				wantXHRConstructor: false
			});

			win.sendAsyncMessage = sendAsyncMessage;
			win.addMessageListener = listener_ON;
			win.removeMessageListener = listener_OFF;

			var lss = Services.scriptloader.loadSubScript;

			lss(app_baseURI + "app.js", win);

			if (win.document instanceof win.window.ImageDocument
				|| win.document.querySelector("body>video:only-child:not([src])")) {
				lss(app_baseURI + "viewer.js", win);
			}
			else {
				lss(app_baseURI + "opener.js", win);
			}
		}
	};

	Services.obs.addObserver(DOM_observer, "content-document-global-created", false);
})();